/*
 * TestListener.h
 */

#ifndef cppunit_TestListener_h
#define cppunit_TestListener_h

#include "cuconfig.h"

cu_NAMESPACE_BEGIN(cppunit)

class Test;
class TestFailure;

/**
 * ƥȤΥꥹʡ<br>
 * A Listener for test progress.
 *
 * @see TestResult
 */
class TestListener
{
  public:
	/** ǥȥ饯 */
	virtual ~TestListener() {}

	/**
	 * ƥȤϤ
	 * @param test ƥȡ
	 */
	virtual void startTest(Test* test) = 0;

	/**
	 * ƥȤλ
	 * @param test ƥȡ
	 */
	virtual void endTest(Test* test) = 0;

	/**
	 * ƥȤμԤɲä줿
	 * @param failure ԤƥȤξ
	 */
	virtual void addFailure(const TestFailure* failure) = 0;

	/**
	 * 顼ɲä줿
	 * @param error 顼
	 */
	virtual void addError(const TestFailure* error) = 0;
};

cu_NAMESPACE_END

#endif /* !cppunit_TestListener_h */
