/*
 * TestSetup.h
 */

#ifndef cppunit_TestSetup_h
#define cppunit_TestSetup_h

#include "cuconfig.h"
#include "TestCase.h"
#include "TestDecorator.h"

cu_NAMESPACE_BEGIN(cppunit)

/**
 * ƥȤνդɲäǥ졼<br>
 * Decorator to set up and tear down additional fixture state.
 *
 * ͭ Test Υ饤ե롣
 */
class TestSetup : public TestDecorator
{
  public:
	/**
	 * 󥹥ȥ饯
	 * @param test ˤʤƥȡ
	 */
	explicit TestSetup(Test* test);

	virtual void run(TestResult* result);

  protected:
	/** ƥȤ롣 */
	virtual void setUp() {}

	/** ƥȤθդ򤹤롣 */
	virtual void tearDown() {}

	/** ºݤ˥ƥȤ¹Ԥ롣 */
	void runBare();

//	#define TEST_ERROR(msg)
	/**
	 * 顼ɲä롣
	 * @param msg  å
	 * @param file ȯե̾
	 * @param line ȯֹ档
	 * @see TEST_ERROR
	 */
	void addError(const cu_String& msg, const char* file, long line);

  private:
	TestSetup(const TestSetup& rhs);
	TestSetup& operator=(const TestSetup& rhs);

  private:
	bool m_hasError;
	TestResult* m_result;	// ¹åȤ롣
};

cu_NAMESPACE_END

#endif /* !cppunit_TestSetup_h */
