
# common definition for Makefile
# for GNU c++
CXX = g++ -x c++
LD = g++
CP = cp -f
AR = ar r
MKDIR=mkdir -p
RM=rm -f
#PROF=-pg
FFP=-fomit-frame-pointer
#BOOST=-I/usr/local/include
CFLAGS = $(PROF) -Wall -O3 -c $(FFP) -D_FILE_OFFSET_BITS=64 -DNDEBUG $(BOOST)
#CFLAGS = $(PROF) -Wall -O2 -c -D_FILE_OFFSET_BITS=64 -DNDEBUG
LDFLAGS = $(PROF) -lm
AS = nasm
AFLAGS = -f elf -D__unix__ -i./x86/
