/**
	ʰץ󥽡
	@brief
	@author $Author: dskw $
	@version $Revision: 1.2 $
	@date $Date: 2005/02/22 09:45:24 $
*/

#define USE_F4
#define USE_HFE
#define MAIN_INSTANCE_HERE
#include "hotaru.h"
#include <fstream>
#include <unistd.h>
#include <sys/stat.h>

using namespace Hotaru;
using namespace std;


int main(int ac, char *av[]) {
	if(ac < 2) exit(0);
	int num = ::atoi(av[1]);
	
	static char fname[32];
	struct stat sb;
	
	changeInputFormat(ALPHABET);
	changeOutputFormat(ALPHABET);
	
	::sprintf(fname, "G%d", num);
	ofstream ofs(fname, ios::trunc|ios::out); ofs.close();
	
	for (;;) {
		for(;;) {
			::sprintf(fname, "F%d", num);
			if(!::stat(fname, &sb)) break;
			::usleep(1000);
		}
		
		F2poly::Set G;
		::sprintf(fname, "F%d", num);
		ifstream inF(fname);
		string s;
		while(getline(inF, s)) G.push_back(F2poly(s.c_str()));
		inF.close();
		::unlink(fname);
cout << "Input Problem:" << endl;
PutF2polySet(G, ' ');
		
		F4::MakeGbaseBy(G);
std::cout << "Calc complete. Writing a file" << std::endl;
		
		::sprintf(fname, "_G%d", num);
		ofstream outG(fname, ios::trunc|ios::out);
		F2poly::Set::iterator iG = G.begin();
		for(; iG != G.end(); ++iG) outG << *iG << endl;
		outG.close();
		::rename(fname, fname+1);
	}
	return 0;
}
