/**
	ʰץ󥽡
	@brief ֥ʡ׻ġ
	@author $Author: dskw $
	@version $Revision: 1.1 $
	@date $Date: 2005/02/22 05:45:49 $
*/

#define USE_PARAHFE
#define USE_HFE
#define MAIN_INSTANCE_HERE
#include "hotaru.h"
#include <time.h>

using namespace Hotaru;
using namespace std;

#define METHOD ParaHFE

int main(int ac, char *av[])
{
	if(ac < 2) exit(0);
	METHOD::nLevel = ::atoi(av[1]);
	cout << "HOTARU ver. " << (VERSION >> 8) << "." << (VERSION & 0xFF) << endl;
	cout << "Copyright (C) 2004 herumi and dsk." << endl;
	cout << "METHOD:" << METHOD::getString() << endl;
	for (;;) {
		F2poly::Set G;

		cout << "input polynomials." << endl;
		cout << "type .(period) if you want to stop." << endl;

		changeInputFormat(ALPHABET);
		changeOutputFormat(ALPHABET);

		bool isEnd = false;
		do {
			const size_t lineMax = 65536;
			string expr;
			/*
				1ԤʣԤˤʤäƤ褤1Ԥν,ȽǤ롥
				ϤνƬ.ιԤǤ롥
				ޤΤȤˤϲ⼰̵Ȥ()
			*/
			for (;;) {
				char line[lineMax];
				cin.getline(line, lineMax);

				if (*line == '.') {
					/* ХåեˤΤϺǽ */
					F2poly f(expr.c_str());
					if (!f.isZero()) {
						G.push_back(f);
					}
					isEnd = true;
					break;
				}
				expr += line;
				if (find(expr.rbegin(), expr.rend(), ',') != expr.rend()) {
					F2poly f(expr.c_str());
					if (!f.isZero()) {
						G.push_back(f);
						break;
					}
				}
			}
		} while (!isEnd);
		if (G.size()) {
			cout << "input polynomials are:" << endl;
			PutF2polySet(G, 'G');
			cout << "computing Groebner basis." << endl;
			clock_t begin = clock();
			METHOD::MakeGbaseBy(G);
			clock_t end = clock();
			double second = (end - begin) / double(CLOCKS_PER_SEC);
			for (F2poly::Set::const_iterator itr = G.begin(); itr != G.end(); ++itr) {
				cout << *itr << ',' << endl;
			}
			cout << "num of G:" << G.size() << endl;
			cout << "time:" << second << "sec" << endl;

		} else {
			break;
		}
	}
	return 0;
}
