/*
	F2termx4饹ƥ
	ѥ뤹Ȥ
	class F2poly : private POLY_CONT <F2term OPTIONAL_COMP OPTIONAL_ALLOC>
	publicˤ뤳
*/
#define MAIN_INSTANCE_HERE
#include "hotaru.h"
#include "f2poly.h"
#include "f2term.h"
#include "f2termx4.h"

int main()
{
	F2term a, b, c, d;
	F2term C("(1, 2, 3)");
	a = F2term("(0, 9, 8, 3)");
	b = F2term("(0, 1)");
	c = F2term("(1)");
	d = F2term("(2, 3, 4)");
	F2term t("(1, 2, 3)");

	F2term *pterm[4] = {&a, &b, &c, &d};
	F2termx4 v(pterm);

	for (int i = 0; i < 100; i++) {
		v.mul(t);
	}

	for (int i = 0; i < 4; i++) {
		F2term e;
		e = *pterm[i];
		e *= C;
		std::cout << "org  i=" << i << ":" << e << ":deg=" << e.getDegree() << std::endl;
		e = v.get(i);
		std::cout << "vect i=" << i << ":" << e << ":deg=" << e.getDegree() << std::endl;
	}

	{
		uint32 **p = (uint32**)pterm;
		puts("before mul");
		for (int i = 0; i < 4; i++) {
			printf("p[%d]=%08X:%08X\n", i, p[i][0], p[i][1]);
		}
		puts("after mul");
		for (int i = 0; i < 4; i++) {
			F2term u;
			u = t;
			u *= *pterm[i];
			uint32*p = (uint32*)&u;
			printf("p[%d]=%08X:%08X\n", i, p[0], p[1]);
		}
	}

	{
		F2poly f;
		f += a; f += b; f += c; f += d;
		F2poly::iterator itr;
		itr = f.begin();
		puts("before mul");
		printf("&*itr=%p, %08X:%08X\n", &*itr, *(uint32*)(&*itr), *((uint32*)(&*itr) + 1));
		++itr;
		printf("&*itr=%p, %08X:%08X\n", &*itr, *(uint32*)(&*itr), *((uint32*)(&*itr) + 1));
		++itr;
		printf("&*itr=%p, %08X:%08X\n", &*itr, *(uint32*)(&*itr), *((uint32*)(&*itr) + 1));
		++itr;
		printf("&*itr=%p, %08X:%08X\n", &*itr, *(uint32*)(&*itr), *((uint32*)(&*itr) + 1));
		++itr;

		itr = f.begin();
		mul_f2termx4_SSE2(&itr, &t, 4);

		puts("after mul");
		itr = f.begin();
		printf("&*itr=%p, %08X:%08X\n", &*itr, *(uint32*)(&*itr), *((uint32*)(&*itr) + 1));
		++itr;
		printf("&*itr=%p, %08X:%08X\n", &*itr, *(uint32*)(&*itr), *((uint32*)(&*itr) + 1));
		++itr;
		printf("&*itr=%p, %08X:%08X\n", &*itr, *(uint32*)(&*itr), *((uint32*)(&*itr) + 1));
		++itr;
		printf("&*itr=%p, %08X:%08X\n", &*itr, *(uint32*)(&*itr), *((uint32*)(&*itr) + 1));
		++itr;

	}

	{
		F2poly f("(1, 2, 3)+(0, 9, 8, 3)+(0,1) + (1) +(2,3,4)+(5,3,9)+(8,3,0)+(1,8,3)");
		f *= a;
		std::cout << "asm " << f << std::endl;
		printf("org (0, 1, 2, 3, 8, 9) + (0, 2, 3, 4, 8, 9) + (0, 1, 3, 8, 9) + (0, 3, 5, 8, 9)\n");
	}

	return 0;
}
