/**
	ʰץ󥽡
	@brief ֥ʡ׻ġ
	@author $Author: herumi $
	@version $Revision: 1.34 $
	@date $Date: 2005/02/23 16:21:53 $
*/

#define USE_F4
#define USE_HFE
//#define USE_SUGAR
#define MAIN_INSTANCE_HERE
#include "hotaru.h"
#include <time.h>

using namespace Hotaru;
using namespace std;

#ifndef USE_F4
//	#define METHOD	Basic
	#define METHOD	History
//	#define METHOD	PairSet
//	#define USE_AFTER_REDUCE
#else
	#define METHOD	F4
#endif

#if 0
int main()
{
	changeInputFormat(ALPHABET);
	changeOutputFormat(ALPHABET);

	for (;;) {
		char line[65536];
		cin.getline(line, sizeof(line));

		F2poly f(line);

		const F2term& LMf = f.LM();

		for (size_t j = 0; j < Hotaru::MAX_NUM_OF_VARIABLE; j++) {
			if (LMf.hasVar(j)) {
				/*
					äȸΨ
				*/
				F2poly s = f;
				F2term t; t.setVar(j);
				s *= t;
				s -= f; // s = xi f - f
				cout << "S" << j << "(f)=" << s << endl;
			}
		}
	}
	return 0;
}
#else
int main()
{
	cout << "HOTARU ver. " << (VERSION >> 8) << "." << (VERSION & 0xFF) << endl;
	cout << "Copyright (C) 2004 herumi and dsk." << endl;
	cout << "METHOD:" << METHOD::getString() << endl;
	for (;;) {
		F2poly::Set G;

		cout << "input polynomials." << endl;
		cout << "type .(period) if you want to stop." << endl;

		changeInputFormat(ALPHABET);
		changeOutputFormat(ALPHABET);

#if 1
		bool isEnd = false;
		do {
			const size_t lineMax = 65536;
			string expr;
			/*
				1ԤʣԤˤʤäƤ褤1Ԥν,ȽǤ롥
				ϤνƬ.ιԤǤ롥
				ޤΤȤˤϲ⼰̵Ȥ()
			*/
			for (;;) {
				char line[lineMax];
				cin.getline(line, lineMax);

				if (*line == '.') {
					/* ХåեˤΤϺǽ */
					F2poly f(expr.c_str());
					if (!f.isZero()) {
						G.push_back(f);
					}
					isEnd = true;
					break;
				}
				expr += line;
				if (find(expr.rbegin(), expr.rend(), ',') != expr.rend()) {
					F2poly f(expr.c_str());
					if (!f.isZero()) {
						G.push_back(f);
						break;
					}
				}
			}
		} while (!isEnd);
#else
		for (;;) {
			char line[65536];
			cin.getline(line, sizeof(line));

			if (*line == '.') {
				cout << "input end." << endl;
				break;
			} else {
				F2poly f(line);
				if (!f.isZero()) {
					G.push_back(f);
				}
			}
		}
#endif
		if (G.size()) {
			cout << "input polynomials are:" << endl;
			PutF2polySet(G, 'G');
			cout << "computing Groebner basis." << endl;
			clock_t begin = clock();
			METHOD::MakeGbaseBy(G);
#ifdef USE_AFTER_REDUCE
			History::Reduce(G);
#endif
			clock_t end = clock();
			double second = (end - begin) / double(CLOCKS_PER_SEC);
#if 1
			for (F2poly::Set::const_iterator itr = G.begin(); itr != G.end(); ++itr) {
				cout << *itr << ',' << endl;
			}
			cout << "num of G:" << G.size() << endl;
#else
			PutF2polySet(G, 'G');
			cout << "result:" << endl;
#endif
			cout << "time:" << second << "sec" << endl;

		} else {
			break;
		}
	}
//	clkput();
	return 0;
}
#endif
