/*
 * RepeatedTest.h
 */

#ifndef cppunit_RepeatedTest_h
#define cppunit_RepeatedTest_h

#include "cuconfig.h"
#include "TestDecorator.h"

cu_NAMESPACE_BEGIN(cppunit)

/**
 * ƱƥȤ򷫤֤¹Ԥǥ졼<br>
 * Decorator that runs a test repeatedly.
 *
 * ͭ Test Υ饤ե롣
 */
class RepeatedTest : public TestDecorator
{
  public:
	/**
	 * 󥹥ȥ饯
	 * @param test   ¹Ԥƥȡ
	 * @param repeat ֤
	 */
	RepeatedTest(Test* test, int repeat);

	virtual void run(TestResult* result);
	virtual int countTestCases() const;
	virtual cu_String toString() const;

  private:
	RepeatedTest(const RepeatedTest& rhs);
	RepeatedTest& operator=(const RepeatedTest& rhs);

  private:
	const int m_timesRepeat;
};

cu_NAMESPACE_END

#endif /* !cppunit_RepeatedTest_h */
