#ifndef HOTARU_H_
#define HOTARU_H_
/**
	@file hotaru.h
	@brief ֥ʡ׻ġ
	@author $Author: dskw $
	@version $Revision: 1.15 $
	@date $Date: 2005/02/26 07:41:51 $
*/
#include "hotaru_config.h"
#include "f2poly.h"

#if defined(USE_PARAF4) || defined(USE_PARAHFE) || defined(USE_F5)
#define USE_F4
#endif

#ifndef USE_F4
#include "hotaru_basic.h" /* ʽ̤η׻ˡ(Ѥ򤢤) */
#include "hotaru_history.h" /* դƥ */
#include "hotaru_pairset.h" /* ڥ */

/*
	ΤϤ
*/
#ifdef MAIN_INSTANCE_HERE
	#ifdef USE_MYLIST
		#define POOL_NEED_INSTANCE
		#define POOL_IMP mylistimp
		typedef F2term BASE_TYPE;
		#define INST mylistimp::cont_base
	#elif defined(USE_MYSET)
		#define POOL_NEED_INSTANCE
		#define POOL_IMP mysetimp
		typedef F2term BASE_TYPE;
		#define INST mysetimp::tree_base
	#endif
	#if defined(USE_MYALLOC)
		#define POOL_NEED_INSTANCE
		#ifdef USE_SET
			typedef std::_Rb_tree_node<Hotaru::F2term> BASE_TYPE;
		#else
			typedef std::_List_node<Hotaru::F2term> BASE_TYPE;
		#endif
		#define POOL_IMP myallocimp
		#define INST myalloc
	#endif
	#if defined(POOL_NEED_INSTANCE)
		POOL_IMP::mypool<BASE_TYPE, Hotaru::POOL_NODE_NUM> 
			INST<BASE_TYPE, Hotaru::POOL_NODE_NUM>::pool_;
	#endif
#endif // MAIN_INSTANCE_HERE



#else  // F4

#ifdef MAIN_INSTANCE_HERE
	#if defined(USE_MYLIST) || defined(USE_MYSET)
		#define POOL_NEED_INSTANCE
		typedef F2term BASE_TYPE;
		#if defined(USE_MYLIST)
			#define POOL_IMP mylistimp
			#define INST mylistimp::cont_base
		#else
			#define POOL_IMP mysetimp
			#define INST mysetimp::tree_base
		#endif
		#define POOL_PAIR_IMP mylistimp
		#define PAIR_TYPE F4::Pair
		#define INST_PAIR mylistimp::cont_base
	#elif defined(USE_MYALLOC)
		#define POOL_NEED_INSTANCE
		#ifdef USE_SET
			typedef std::_Rb_tree_node<F2term> BASE_TYPE;
		#else
			typedef std::_List_node<F2term> BASE_TYPE;
		#endif
		#define POOL_IMP myallocimp
		#define INST myalloc
		#define POOL_PAIR_IMP myallocimp
		#define PAIR_TYPE std::_List_node<F4::Pair>
		#define INST_PAIR myalloc
	#endif
#endif // MAIN_INSTANCE_HERE

#if defined(USE_PARAF4) || defined(USE_PARAHFE)
#include "parent.h"
#else
#include "hotaru_f4.h"
#endif

#if defined(POOL_NEED_INSTANCE)
	POOL_IMP::mypool<BASE_TYPE, POOL_NODE_NUM> 
		INST<BASE_TYPE, POOL_NODE_NUM>::pool_;
	POOL_PAIR_IMP::mypool<PAIR_TYPE, POOL_PAIR_NUM>
		INST_PAIR<PAIR_TYPE, POOL_PAIR_NUM>::pool_;
#endif



#endif // F4

#endif /* HOTARU_H_ */
