
;	@brief F2term
;	@author $Author: herumi $
;	@version $Revision: 1.4 $
;	@date $Date: 2005/02/17 14:59:36 $

%include "nasm.cfg"

;externdef incIter_C

		segment_data
c55555555	dd 0x55555555, 0x55555555, 0x55555555, 0x55555555
c33333333	dd 0x33333333, 0x33333333, 0x33333333, 0x33333333
c0F0F0F0F	dd 0x0F0F0F0F, 0x0F0F0F0F, 0x0F0F0F0F, 0x0F0F0F0F
c00FF00FF	dd 0x00FF00FF, 0x00FF00FF, 0x00FF00FF, 0x00FF00FF
c0000003F	dd 0x0000003F, 0x0000003F, 0x0000003F, 0x0000003F

work		dd 0, 0, 0, 0, 0, 0, 0, 0
save_ptr	dd 0, 0, 0, 0

; F2termμ
; +0 subset_
; +4 degree_


; F2poly::iterator
; struct node_base { node_base *next_, *prev_; };
; struct iter_base { node_base *node_; }
; next iterator = node->next

		segment_text


%macro incIter 1
			mov		ecx, [%1]
			lea		eax, [ecx+8]
			mov		ecx, [ecx]
			mov		[%1], ecx
%endmacro

%define incIter_C _incIter_C

; 2005/2/16 first version 4400clk@D12

proc mul_f2termx4_SSE2;(iterator* pitr, const F2term* rhs, size_t n);
		push		ebx
		push		esi
		push		edi
		push		ebp
%assign _P 4*4
		mov			esi, [esp+_P+4]		; esi = pitr
		mov			edi, [esp+_P+8]		; edi = rhs
		mov			ebp, [esp+_P+12]	; ebp = n

		movss		xm7, [edi]			; rsh.subset_
		shufps		xm7, xm7, PACK(0, 0, 0, 0)	; xm7 = [rhs:rhs:rhs:rhs]
		movaps		xm6, [c55555555]
		movaps		xm5, [c33333333]
		movaps		xm4, [c0F0F0F0F]
		movaps		xm3, [c0000003F]

.lp:
		mov			ecx, [esi]
		movss		xm0, [ecx+8]		; xm0 = [*:*:*:itr0]
		mov			[save_ptr + 0], ecx

		mov			ecx, [ecx]			; next iter
		movss		xm1, [ecx+8]		; xm1 = [*:*:*:itr1]
		mov			[save_ptr + 4], ecx

		unpcklps	xm0, xm1

		mov			ecx, [ecx]
		movss		xm1, [ecx+8]		; xm1 = [*:*:*:itr2]
		mov			[save_ptr + 8], ecx

		mov			ecx, [ecx]
		movss		xm2, [ecx+8]		; xm2 = [*:*:*:itr3]
		mov			[save_ptr +12], ecx
		mov			[esi], ecx

		unpcklps	xm1, xm2			; xm1 = [*:*:itr3:itr2]
		movlhps		xm0, xm1			; xm0 = [itr3:itr2:itr1:itr0]

		orps		xm0, xm7			; xm0 *= rhs
		movaps		xm2, xm0			; xm2 = [new subset]

		movaps		xm1, xm0
		psrld		xm0, 1
		andps		xm0, xm6
		psubd		xm1, xm0
		movaps		xm0, xm1
		andps		xm1, xm5
		psrld		xm0, 2
		andps		xm0, xm5
		paddd		xm0, xm1
		movaps		xm1, xm0
		psrld		xm0, 4
		paddd		xm0, xm1
		andps		xm0, xm4
		movaps		xm1, xm0
		psrld		xm0, 8
		paddd		xm0, xm1
		movaps		xm1, xm0
		psrld		xm0, 16
		paddd		xm0, xm1
		andps		xm0, xm3

		; xm2 = [sub3:sub2:sub1:sub0]
		; xm0 = [deg3:deg2:deg1:deg0]

		movaps		xm1, xm2
		punpckldq	xm1, xm0			; [deg1:sub1:deg0:sub0]

		mov			eax, [save_ptr + 0]
		movq		[eax+8], xm1
		shufps		xm1, xm1, PACK(3, 2, 3, 2)

		mov			eax, [save_ptr + 4]
		movq		[eax+8], xm1

		movaps		xm1, xm2
		punpckhdq	xm1, xm0			; [deg3:sub3:deg2:sub2]

		mov			eax, [save_ptr + 8]
		movq		[eax+8], xm1
		shufps		xm1, xm1, PACK(3, 2, 3, 2)

		mov			eax, [save_ptr +12]
		movq		[eax+8], xm1

		sub			ebp, byte 4
		cmp			ebp, byte 4
		jge			near .lp
.exit:
		pop			ebp
		pop			edi
		pop			esi
		pop			ebx
		ret

		end
